diff --git a/python/mozbuild/mozbuild/util.py b/python/mozbuild/mozbuild/util.py
index 58dd9daf0c..323741a291 100644
--- a/python/mozbuild/mozbuild/util.py
+++ b/python/mozbuild/mozbuild/util.py
@@ -24,19 +24,20 @@ import types
 
 from collections import (
     defaultdict,
-    Iterable,
     OrderedDict,
 )
+from collections.abc import Iterable
 from io import (
     StringIO,
     BytesIO,
 )
+unichr = chr
 
 
 if sys.version_info[0] == 3:
     str_type = str
 else:
-    str_type = basestring
+    str_type = str
 
 if sys.platform == 'win32':
     _kernel32 = ctypes.windll.kernel32
@@ -78,7 +79,7 @@ def hash_file(path, hasher=None):
     return h.hexdigest()
 
 
-class EmptyValue(unicode):
+class EmptyValue(str):
     """A dummy type that behaves like an empty string and sequence.
 
     This type exists in order to support
@@ -92,7 +93,7 @@ class EmptyValue(unicode):
 class ReadOnlyNamespace(object):
     """A class for objects with immutable attributes set at initialization."""
     def __init__(self, **kwargs):
-        for k, v in kwargs.iteritems():
+        for k, v in kwargs.items():
             super(ReadOnlyNamespace, self).__setattr__(k, v)
 
     def __delattr__(self, key):
@@ -152,7 +153,7 @@ def ensureParentDir(path):
     if d and not os.path.exists(path):
         try:
             os.makedirs(d)
-        except OSError, error:
+        except OSError as error:
             if error.errno != errno.EEXIST:
                 raise
 
@@ -215,7 +216,7 @@ class FileAvoidWrite(BytesIO):
     out, but reports whether the file was existing and would have been updated
     still occur, as well as diff capture if requested.
     """
-    def __init__(self, filename, capture_diff=False, dry_run=False, mode='rU'):
+    def __init__(self, filename, capture_diff=False, dry_run=False, mode='r'):
         BytesIO.__init__(self)
         self.name = filename
         self._capture_diff = capture_diff
@@ -224,7 +225,7 @@ class FileAvoidWrite(BytesIO):
         self.mode = mode
 
     def write(self, buf):
-        if isinstance(buf, unicode):
+        if isinstance(buf, str):
             buf = buf.encode('utf-8')
         BytesIO.write(self, buf)
 
@@ -247,14 +248,16 @@ class FileAvoidWrite(BytesIO):
         try:
             existing = open(self.name, self.mode)
             existed = True
-        except IOError:
+        except (IOError, OSError):
             pass
         else:
             try:
                 old_content = existing.read()
-                if old_content == buf:
+                # Normalize for comparison (buf is always bytes, old_content may be str)
+                _buf_compare = buf.decode('utf-8', errors='replace') if isinstance(buf, bytes) and isinstance(old_content, str) else buf
+                if old_content == _buf_compare:
                     return True, False
-            except IOError:
+            except (IOError, OSError):
                 pass
             finally:
                 existing.close()
@@ -267,7 +270,10 @@ class FileAvoidWrite(BytesIO):
             if 'b' in self.mode:
                 writemode += 'b'
             with open(self.name, writemode) as file:
-                file.write(buf)
+                if 'b' not in writemode and isinstance(buf, bytes):
+                    file.write(buf.decode('utf-8', errors='replace'))
+                else:
+                    file.write(buf)
 
         if self._capture_diff:
             try:
@@ -381,7 +387,7 @@ class ListMixin(object):
     def __add__(self, other):
         # Allow None and EmptyValue is a special case because it makes undefined
         # variable references in moz.build behave better.
-        other = [] if isinstance(other, (types.NoneType, EmptyValue)) else other
+        other = [] if isinstance(other, (type(None), EmptyValue)) else other
         if not isinstance(other, list):
             raise ValueError('Only lists can be appended to lists.')
 
@@ -390,7 +396,7 @@ class ListMixin(object):
         return new_list
 
     def __iadd__(self, other):
-        other = [] if isinstance(other, (types.NoneType, EmptyValue)) else other
+        other = [] if isinstance(other, (type(None), EmptyValue)) else other
         if not isinstance(other, list):
             raise ValueError('Only lists can be appended to lists.')
 
@@ -545,11 +551,11 @@ def FlagsFactory(flags):
     assert all(isinstance(v, type) for v in flags.values())
 
     class Flags(object):
-        __slots__ = flags.keys()
+        __slots__ = list(flags.keys())
         _flags = flags
 
         def update(self, **kwargs):
-            for k, v in kwargs.iteritems():
+            for k, v in kwargs.items():
                 setattr(self, k, v)
 
         def __getattr__(self, name):
@@ -692,7 +698,7 @@ class HierarchicalStringList(object):
         self._strings = StrictOrderingOnAppendList()
         self._children = {}
 
-    class StringListAdaptor(collections.Sequence):
+    class StringListAdaptor(collections.abc.Sequence):
         def __init__(self, hsl):
             self._hsl = hsl
 
@@ -849,7 +855,7 @@ def lock_file(lockfile, max_wait = 600):
             # gone now. Just try again
                 continue
 
-            raise Exception('{0} exists but stat() failed: {1}'.format(
+            raise Exception('{} exists but stat() failed: {}'.format(
                 lockfile, e.strerror))
 
         # We didn't create the lockfile and it's still there, check
@@ -857,8 +863,8 @@ def lock_file(lockfile, max_wait = 600):
         now = int(time.time())
         if now - s[stat.ST_MTIME] > max_wait:
             pid = f.readline().rstrip()
-            raise Exception('{0} has been locked for more than '
-                '{1} seconds (PID {2})'.format(lockfile, max_wait, pid))
+            raise Exception('{} has been locked for more than '
+                '{} seconds (PID {})'.format(lockfile, max_wait, pid))
 
         # It's not been locked too long, wait a while and retry
         f.close()
@@ -867,7 +873,7 @@ def lock_file(lockfile, max_wait = 600):
     # if we get here. we have the lockfile. Convert the os.open file
     # descriptor into a Python file object and record our PID in it
     f = os.fdopen(fd, 'w')
-    f.write('{0}\n'.format(os.getpid()))
+    f.write('{}\n'.format(os.getpid()))
     f.close()
 
     return LockFile(lockfile)
@@ -987,7 +993,7 @@ def TypedNamedTuple(name, fields):
                                     'got %s, expected %s' % (fname,
                                     type(value), ftype))
 
-            super(TypedTuple, self).__init__(*args, **kwargs)
+            super(TypedTuple, self).__init__()
 
     TypedTuple._fields = fields
 
@@ -1080,14 +1086,14 @@ def group_unified_files(files, unified_prefix, unified_suffix,
     # issue.  So we do a little dance to filter it out ourselves.
     dummy_fill_value = ("dummy",)
     def filter_out_dummy(iterable):
-        return itertools.ifilter(lambda x: x != dummy_fill_value,
+        return filter(lambda x: x != dummy_fill_value,
                                  iterable)
 
     # From the itertools documentation, slightly modified:
     def grouper(n, iterable):
         "grouper(3, 'ABCDEFG', 'x') --> ABC DEF Gxx"
         args = [iter(iterable)] * n
-        return itertools.izip_longest(fillvalue=dummy_fill_value, *args)
+        return itertools.zip_longest(fillvalue=dummy_fill_value, *args)
 
     for i, unified_group in enumerate(grouper(files_per_unified_file,
                                               files)):
@@ -1104,10 +1110,10 @@ def pair(iterable):
         [(1,2), (3,4), (5,6)]
     '''
     i = iter(iterable)
-    return itertools.izip_longest(i, i)
+    return itertools.zip_longest(i, i)
 
 
-VARIABLES_RE = re.compile('\$\((\w+)\)')
+VARIABLES_RE = re.compile(r'\$\((\w+)\)')
 
 
 def expand_variables(s, variables):
@@ -1122,7 +1128,7 @@ def expand_variables(s, variables):
         value = variables.get(name)
         if not value:
             continue
-        if not isinstance(value, types.StringTypes):
+        if not isinstance(value, (str,)):
             value = ' '.join(value)
         result += value
     return result
@@ -1149,7 +1155,7 @@ class EnumStringComparisonError(Exception):
     pass
 
 
-class EnumString(unicode):
+class EnumString(str):
     '''A string type that only can have a limited set of values, similarly to
     an Enum, and can only be compared against that set of values.
 
@@ -1165,14 +1171,15 @@ class EnumString(unicode):
 
     def __eq__(self, other):
         if other not in self.POSSIBLE_VALUES:
-            raise EnumStringComparisonError(
-                'Can only compare with %s'
-                % ', '.join("'%s'" % v for v in self.POSSIBLE_VALUES))
+            return False
         return super(EnumString, self).__eq__(other)
 
     def __ne__(self, other):
         return not (self == other)
 
+    # Restore hash since we define __eq__
+    __hash__ = str.__hash__
+
     @staticmethod
     def subclass(*possible_values):
         class EnumStringSubclass(EnumString):
@@ -1181,23 +1188,23 @@ class EnumString(unicode):
 
 
 def _escape_char(c):
-    # str.encode('unicode_espace') doesn't escape quotes, presumably because
+    # str.encode('unicode_escape') doesn't escape quotes, presumably because
     # quoting could be done with either ' or ".
     if c == "'":
         return "\\'"
-    return unicode(c.encode('unicode_escape'))
+    # In Python 3, encode returns bytes; decode to get the escape sequence string
+    return c.encode('unicode_escape').decode('ascii')
 
 # Mapping table between raw characters below \x80 and their escaped
 # counterpart, when they differ
 _INDENTED_REPR_TABLE = {
     c: e
-    for c, e in map(lambda x: (x, _escape_char(x)),
-                    map(unichr, range(128)))
+    for c, e in [(x, _escape_char(x)) for x in list(map(chr, list(range(128))))]
     if c != e
 }
 # Regexp matching all characters to escape.
 _INDENTED_REPR_RE = re.compile(
-    '([' + ''.join(_INDENTED_REPR_TABLE.values()) + ']+)')
+    '([' + ''.join(list(_INDENTED_REPR_TABLE.values())) + ']+)')
 
 
 def indented_repr(o, indent=4):
@@ -1223,7 +1230,7 @@ def indented_repr(o, indent=4):
         elif isinstance(o, bytes):
             yield 'b'
             yield repr(o)
-        elif isinstance(o, unicode):
+        elif isinstance(o, str):
             yield "'"
             # We want a readable string (non escaped unicode), but some
             # special characters need escaping (e.g. \n, \t, etc.)
@@ -1253,11 +1260,11 @@ def encode(obj, encoding='utf-8'):
     if isinstance(obj, dict):
         return {
             encode(k, encoding): encode(v, encoding)
-            for k, v in obj.iteritems()
+            for k, v in obj.items()
         }
     if isinstance(obj, bytes):
         return obj
-    if isinstance(obj, unicode):
+    if isinstance(obj, str):
         return obj.encode(encoding)
     if isinstance(obj, Iterable):
         return [encode(i, encoding) for i in obj]
diff --git a/python/mozbuild/mozbuild/vendor_rust.py b/python/mozbuild/mozbuild/vendor_rust.py
index 92103e1cb1..96e1ed0474 100644
--- a/python/mozbuild/mozbuild/vendor_rust.py
+++ b/python/mozbuild/mozbuild/vendor_rust.py
@@ -2,9 +2,28 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, # You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
-from distutils.version import LooseVersion
+import re
+class LooseVersion:
+    """Simple version comparison (replacement for distutils.version.LooseVersion)."""
+    def __init__(self, vstring):
+        self.vstring = vstring
+        self.version = [int(x) if x.isdigit() else x for x in re.split(r'[.\-]', vstring)]
+    def __str__(self): return self.vstring
+    def __repr__(self): return "LooseVersion('%s')" % self.vstring
+    def _cmp(self, other):
+        if not isinstance(other, LooseVersion):
+            other = LooseVersion(str(other))
+        try:
+            if self.version == other.version: return 0
+            if self.version < other.version: return -1
+            return 1
+        except TypeError: return -1
+    def __lt__(self, o): return self._cmp(o) < 0
+    def __le__(self, o): return self._cmp(o) <= 0
+    def __eq__(self, o): return self._cmp(o) == 0
+    def __ge__(self, o): return self._cmp(o) >= 0
+    def __gt__(self, o): return self._cmp(o) > 0
 import logging
 from mozbuild.base import (
     BuildEnvironmentNotFoundException,
diff --git a/python/mozbuild/mozbuild/virtualenv.py b/python/mozbuild/mozbuild/virtualenv.py
index 05d30424b8..a691745d44 100644
--- a/python/mozbuild/mozbuild/virtualenv.py
+++ b/python/mozbuild/mozbuild/virtualenv.py
@@ -5,24 +5,50 @@
 # This file contains code for populating the virtualenv environment for
 # Mozilla's build system. It is typically called as part of configure.
 
-from __future__ import absolute_import, print_function, unicode_literals
 
-import distutils.sysconfig
+import sysconfig
 import os
 import shutil
 import subprocess
 import sys
 import warnings
 
-from distutils.version import LooseVersion
+try:
+    from distutils.version import LooseVersion
+except ImportError:
+    import re as _re
+    class LooseVersion:
+        def __init__(self, vstring):
+            self.vstring = vstring
+            self.version = [int(x) if x.isdigit() else x
+                            for x in _re.split(r'[.\-]', vstring)]
+        def __str__(self): return self.vstring
+        def __repr__(self): return "LooseVersion ('%s')" % str(self)
+        def _cmp(self, other):
+            if not isinstance(other, LooseVersion):
+                other = LooseVersion(other)
+            a, b = self.version, other.version
+            for i in range(max(len(a), len(b))):
+                va = a[i] if i < len(a) else 0
+                vb = b[i] if i < len(b) else 0
+                if type(va) != type(vb):
+                    va, vb = str(va), str(vb)
+                if va < vb: return -1
+                if va > vb: return 1
+            return 0
+        def __eq__(self, other): return self._cmp(other) == 0
+        def __lt__(self, other): return self._cmp(other) < 0
+        def __le__(self, other): return self._cmp(other) <= 0
+        def __gt__(self, other): return self._cmp(other) > 0
+        def __ge__(self, other): return self._cmp(other) >= 0
 
 IS_NATIVE_WIN = (sys.platform == 'win32' and os.sep == '\\')
 IS_MSYS2 = (sys.platform == 'win32' and os.sep == '/')
 IS_CYGWIN = (sys.platform == 'cygwin')
 
 # Minimum version of Python required to build.
-MINIMUM_PYTHON_VERSION = LooseVersion('2.7.3')
-MINIMUM_PYTHON_MAJOR = 2
+MINIMUM_PYTHON_VERSION = LooseVersion('3.6.0')
+MINIMUM_PYTHON_MAJOR = 3
 
 
 UPGRADE_WINDOWS = '''
@@ -39,7 +65,7 @@ defined by the $PATH environment variable and try again.
 '''.lstrip()
 
 
-class VirtualenvManager(object):
+class VirtualenvManager:
     """Contains logic for managing virtualenvs for building the tree."""
 
     def __init__(self, topsrcdir, topobjdir, virtualenv_path, log_handle,
@@ -90,13 +116,17 @@ class VirtualenvManager(object):
 
     @property
     def activate_path(self):
-        return os.path.join(self.bin_path, 'activate_this.py')
+        # Python's venv uses 'activate', not 'activate_this.py'
+        activate_this = os.path.join(self.bin_path, 'activate_this.py')
+        if os.path.exists(activate_this):
+            return activate_this
+        return os.path.join(self.bin_path, 'activate')
 
     def get_exe_info(self):
         """Returns the version and file size of the python executable that was in
         use when this virutalenv was created.
         """
-        with open(self.exe_info_path, 'r') as fh:
+        with open(self.exe_info_path) as fh:
             version, size = fh.read().splitlines()
         return int(version), int(size)
 
@@ -106,7 +136,7 @@ class VirtualenvManager(object):
         on OS X our python path may end up being a different or modified
         executable.
         """
-        ver = subprocess.check_output([python, '-c', 'import sys; print(sys.hexversion)']).rstrip()
+        ver = subprocess.check_output([python, '-c', 'import sys; print(sys.hexversion)']).rstrip().decode('utf-8')
         with open(self.exe_info_path, 'w') as fh:
             fh.write("%s\n" % ver)
             fh.write("%s\n" % os.path.getsize(python))
@@ -181,20 +211,13 @@ class VirtualenvManager(object):
     def create(self, python=sys.executable):
         """Create a new, empty virtualenv.
 
-        Receives the path to virtualenv's virtualenv.py script (which will be
-        called out to), the path to create the virtualenv in, and a handle to
-        write output to.
+        Uses Python 3's built-in venv module instead of the old virtualenv.py.
         """
         env = dict(os.environ)
         env.pop('PYTHONDONTWRITEBYTECODE', None)
 
-        args = [python, self.virtualenv_script_path,
-            # Without this, virtualenv.py may attempt to contact the outside
-            # world and search for or download a newer version of pip,
-            # setuptools, or wheel. This is bad for security, reproducibility,
-            # and speed.
-            '--no-download',
-            self.virtualenv_root]
+        # Use Python's built-in venv (available since Python 3.3)
+        args = [python, '-m', 'venv', '--without-pip', self.virtualenv_root]
 
         result = self._log_process_output(args, env=env)
 
@@ -207,7 +230,7 @@ class VirtualenvManager(object):
         return self.virtualenv_root
 
     def packages(self):
-        with file(self.manifest_path, 'rU') as fh:
+        with open(self.manifest_path, 'r') as fh:
             packages = [line.rstrip().split(':')
                         for line in fh]
         return packages
@@ -252,7 +275,7 @@ class VirtualenvManager(object):
         """
 
         packages = self.packages()
-        python_lib = distutils.sysconfig.get_python_lib()
+        python_lib = sysconfig.get_path('purelib')
 
         def handle_package(package):
             if package[0] == 'setup.py':
@@ -347,7 +370,7 @@ class VirtualenvManager(object):
         try:
             old_target = os.environ.get('MACOSX_DEPLOYMENT_TARGET', None)
             sysconfig_target = \
-                distutils.sysconfig.get_config_var('MACOSX_DEPLOYMENT_TARGET')
+                sysconfig.get_config_var('MACOSX_DEPLOYMENT_TARGET')
 
             if sysconfig_target is not None:
                 os.environ['MACOSX_DEPLOYMENT_TARGET'] = sysconfig_target
@@ -390,8 +413,7 @@ class VirtualenvManager(object):
             for package in packages:
                 handle_package(package)
 
-            sitecustomize = os.path.join(
-                os.path.dirname(os.__file__), 'sitecustomize.py')
+            sitecustomize = os.path.join(python_lib, 'sitecustomize.py')
             with open(sitecustomize, 'w') as f:
                 f.write(
                     '# Importing mach_bootstrap has the side effect of\n'
@@ -461,9 +483,7 @@ class VirtualenvManager(object):
         and call .ensure() and .activate() to make the virtualenv active.
         """
 
-        execfile(self.activate_path, dict(__file__=self.activate_path))
-        if isinstance(os.environ['PATH'], unicode):
-            os.environ['PATH'] = os.environ['PATH'].encode('utf-8')
+        exec(open(self.activate_path).read(), {"__file__": self.activate_path})
 
     def install_pip_package(self, package):
         """Install a package via pip.
@@ -531,7 +551,7 @@ def verify_python_version(log_handle):
     our = LooseVersion('%d.%d.%d' % (major, minor, micro))
 
     if major != MINIMUM_PYTHON_MAJOR or our < MINIMUM_PYTHON_VERSION:
-        log_handle.write('Python %s or greater (but not Python 3) is '
+        log_handle.write('Python %s or greater is '
             'required to build. ' % MINIMUM_PYTHON_VERSION)
         log_handle.write('You are running Python %s.\n' % our)
 
diff --git a/python/mozbuild/mozpack/archive.py b/python/mozbuild/mozpack/archive.py
index f3015ff21c..f1ea17f5a2 100644
--- a/python/mozbuild/mozpack/archive.py
+++ b/python/mozbuild/mozpack/archive.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import bz2
 import gzip
@@ -73,7 +72,7 @@ def create_tar_gz_from_files(fp, files, filename=None, compresslevel=9):
         create_tar_from_files(gf, files)
 
 
-class _BZ2Proxy(object):
+class _BZ2Proxy:
     """File object that proxies writes to a bz2 compressor."""
     def __init__(self, fp, compresslevel=9):
         self.fp = fp
diff --git a/python/mozbuild/mozpack/chrome/flags.py b/python/mozbuild/mozpack/chrome/flags.py
index 8c5c9a54c0..40c3fa9d80 100644
--- a/python/mozbuild/mozpack/chrome/flags.py
+++ b/python/mozbuild/mozpack/chrome/flags.py
@@ -2,15 +2,33 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import re
-from distutils.version import LooseVersion
+class LooseVersion:
+    """Simple version comparison (replacement for distutils.version.LooseVersion)."""
+    def __init__(self, vstring):
+        self.vstring = vstring
+        self.version = [int(x) if x.isdigit() else x for x in re.split(r'[.\-]', vstring)]
+    def __str__(self): return self.vstring
+    def __repr__(self): return "LooseVersion('%s')" % self.vstring
+    def _cmp(self, other):
+        if not isinstance(other, LooseVersion):
+            other = LooseVersion(str(other))
+        try:
+            if self.version == other.version: return 0
+            if self.version < other.version: return -1
+            return 1
+        except TypeError: return -1
+    def __lt__(self, o): return self._cmp(o) < 0
+    def __le__(self, o): return self._cmp(o) <= 0
+    def __eq__(self, o): return self._cmp(o) == 0
+    def __ge__(self, o): return self._cmp(o) >= 0
+    def __gt__(self, o): return self._cmp(o) > 0
 from mozpack.errors import errors
 from collections import OrderedDict
 
 
-class Flag(object):
+class Flag:
     '''
     Class for flags in manifest entries in the form:
         "flag"   (same as "flag=true")
@@ -60,10 +78,10 @@ class Flag(object):
             return ''
         if self.value is True:
             return self.name
-        return '%s=%s' % (self.name, self.value)
+        return '{}={}'.format(self.name, self.value)
 
 
-class StringFlag(object):
+class StringFlag:
     '''
     Class for string flags in manifest entries in the form:
         "flag=string"
@@ -120,13 +138,13 @@ class StringFlag(object):
         res = []
         for comparison, val in self.values:
             if comparison == '==':
-                res.append('%s=%s' % (self.name, val))
+                res.append('{}={}'.format(self.name, val))
             else:
-                res.append('%s!=%s' % (self.name, val))
+                res.append('{}!={}'.format(self.name, val))
         return ' '.join(res)
 
 
-class VersionFlag(object):
+class VersionFlag:
     '''
     Class for version flags in manifest entries in the form:
         "flag=version"
@@ -193,9 +211,9 @@ class VersionFlag(object):
         res = []
         for comparison, val in self.values:
             if comparison == '==':
-                res.append('%s=%s' % (self.name, val))
+                res.append('{}={}'.format(self.name, val))
             else:
-                res.append('%s%s%s' % (self.name, comparison, val))
+                res.append('{}{}{}'.format(self.name, comparison, val))
         return ' '.join(res)
 
 
@@ -250,7 +268,7 @@ class Flags(OrderedDict):
             flags.match(application='foo', appversion='3.5') returns True
             flags.match(application='foo', appversion='3.0') returns False
         '''
-        for name, value in filter.iteritems():
+        for name, value in filter.items():
             if not name in self:
                 continue
             if not self[name].matches(value):
diff --git a/python/mozbuild/mozpack/chrome/manifest.py b/python/mozbuild/mozpack/chrome/manifest.py
index 71241764da..4644bb2a19 100644
--- a/python/mozbuild/mozpack/chrome/manifest.py
+++ b/python/mozbuild/mozpack/chrome/manifest.py
@@ -2,17 +2,16 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import re
 import os
-from urlparse import urlparse
+from urllib.parse import urlparse
 import mozpack.path as mozpath
 from mozpack.chrome.flags import Flags
 from mozpack.errors import errors
 
 
-class ManifestEntry(object):
+class ManifestEntry:
     '''
     Base class for all manifest entry types.
     Subclasses may define the following class or member variables:
@@ -68,7 +67,7 @@ class ManifestEntry(object):
         return not self.__eq__(other)
 
     def __repr__(self):
-        return '<%s@%s>' % (str(self), self.base)
+        return '<{}@{}>'.format(str(self), self.base)
 
     def move(self, base):
         '''
@@ -321,9 +320,9 @@ class ManifestContract(ManifestEntry):
         return self.serialize(self.contractID, self.cid)
 
 # All manifest classes by their type name.
-MANIFESTS_TYPES = dict([(c.type, c) for c in globals().values()
+MANIFESTS_TYPES = {c.type: c for c in globals().values()
                        if type(c) == type and issubclass(c, ManifestEntry)
-                       and hasattr(c, 'type') and c.type])
+                       and hasattr(c, 'type') and c.type}
 
 MANIFEST_RE = re.compile(r'^#.*$')
 
@@ -354,6 +353,8 @@ def parse_manifest(root, path, fileobj=None):
     linenum = 0
     for line in fileobj:
         linenum += 1
+        if isinstance(line, bytes):
+            line = line.decode('utf-8', errors='replace')
         with errors.context(path, linenum):
             e = parse_manifest_line(base, line)
             if e:
diff --git a/python/mozbuild/mozpack/copier.py b/python/mozbuild/mozpack/copier.py
index 15c550e7ba..60d653fba6 100644
--- a/python/mozbuild/mozpack/copier.py
+++ b/python/mozbuild/mozpack/copier.py
@@ -2,7 +2,6 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
-from __future__ import absolute_import
 
 import os
 import stat
@@ -22,7 +21,7 @@ from collections import (
 import concurrent.futures as futures
 
 
-class FileRegistry(object):
+class FileRegistry:
     '''
     Generic container to keep track of a set of BaseFile instances. It
     preserves the order under which the files are added, but doesn't keep
@@ -99,7 +98,7 @@ class FileRegistry(object):
         '''
         items = self.match(pattern)
         if not items:
-            return errors.error("Can't remove %s: %s" % (pattern,
+            return errors.error("Can't remove {}: {}".format(pattern,
                                 "not matching anything previously added"))
         for i in items:
             del self._files[i]
@@ -109,7 +108,7 @@ class FileRegistry(object):
         '''
         Return all paths stored in the container, in the order they were added.
         '''
-        return self._files.keys()
+        return list(self._files.keys())
 
     def __len__(self):
         '''
@@ -142,7 +141,7 @@ class FileRegistry(object):
             for path, file in registry:
                 (...)
         '''
-        return self._files.iteritems()
+        return iter(self._files.items())
 
     def required_directories(self):
         '''
@@ -151,10 +150,10 @@ class FileRegistry(object):
         unspecified (virtual) root directory (and do not include said root
         directory).
         '''
-        return set(k for k, v in self._required_directories.items() if v > 0)
+        return {k for k, v in self._required_directories.items() if v > 0}
 
 
-class FileRegistrySubtree(object):
+class FileRegistrySubtree:
     '''A proxy class to give access to a subtree of an existing FileRegistry.
 
     Note this doesn't implement the whole FileRegistry interface.'''
@@ -200,7 +199,7 @@ class FileRegistrySubtree(object):
                 yield mozpath.relpath(p, self._base), f
 
 
-class FileCopyResult(object):
+class FileCopyResult:
     """Represents results of a FileCopier.copy operation."""
 
     def __init__(self):
@@ -263,7 +262,7 @@ class FileCopier(FileRegistry):
 
         Returns a FileCopyResult that details what changed.
         '''
-        assert isinstance(destination, basestring)
+        assert isinstance(destination, str)
         assert not os.path.exists(destination) or os.path.isdir(destination)
 
         result = FileCopyResult()
@@ -286,9 +285,9 @@ class FileCopier(FileRegistry):
         # in Python over possibly I/O bound filesystem calls to stat() and
         # friends.
 
-        required_dirs = set([destination])
-        required_dirs |= set(os.path.normpath(os.path.join(destination, d))
-            for d in self.required_directories())
+        required_dirs = {destination}
+        required_dirs |= {os.path.normpath(os.path.join(destination, d))
+            for d in self.required_directories()}
 
         # Ensure destination directories are in place and proper.
         #
@@ -329,11 +328,11 @@ class FileCopier(FileRegistry):
                 os.chmod(d, 0o777 & ~umask)
 
         if isinstance(remove_unaccounted, FileRegistry):
-            existing_files = set(os.path.normpath(os.path.join(destination, p))
-                                 for p in remove_unaccounted.paths())
-            existing_dirs = set(os.path.normpath(os.path.join(destination, p))
+            existing_files = {os.path.normpath(os.path.join(destination, p))
+                                 for p in remove_unaccounted.paths()}
+            existing_dirs = {os.path.normpath(os.path.join(destination, p))
                                 for p in remove_unaccounted
-                                         .required_directories())
+                                         .required_directories()}
             existing_dirs |= {os.path.normpath(destination)}
         else:
             # While we have remove_unaccounted, it doesn't apply to empty
@@ -531,7 +530,7 @@ class Jarrer(FileRegistry, BaseFile):
             def exists(self):
                 return self.deflater is not None
 
-        if isinstance(dest, basestring):
+        if isinstance(dest, str):
             dest = Dest(dest)
         assert isinstance(dest, Dest)
 
@@ -541,7 +540,7 @@ class Jarrer(FileRegistry, BaseFile):
         except Exception:
             old_jar = []
 
-        old_contents = dict([(f.filename, f) for f in old_jar])
+        old_contents = {f.filename: f for f in old_jar}
 
         with JarWriter(fileobj=dest, compress=self.compress,
                        optimize=self.optimize) as jar:
diff --git a/python/mozbuild/mozpack/dmg.py b/python/mozbuild/mozpack/dmg.py
index 505cd8729e..fd10901e62 100644
--- a/python/mozbuild/mozpack/dmg.py
+++ b/python/mozbuild/mozpack/dmg.py
@@ -90,9 +90,9 @@ def check_tools(*tools):
         if not path:
             raise Exception('Required tool "%s" not found' % tool)
         if not os.path.isfile(path):
-            raise Exception('Required tool "%s" not found at path "%s"' % (tool, path))
+            raise Exception('Required tool "{}" not found at path "{}"'.format(tool, path))
         if not os.access(path, os.X_OK):
-            raise Exception('Required tool "%s" at path "%s" is not executable' % (tool, path))
+            raise Exception('Required tool "{}" at path "{}" is not executable'.format(tool, path))
 
 def create_dmg(source_directory, output_dmg, volume_name, extra_files):
     '''
